<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class BookableProduct extends Model
{
    use SoftDeletes;
    protected $table = 'ext_bookableProduct';
    protected $primaryKey = 'id';

    public function times() {
        return $this->hasMany(BookingTime::class);
    }

    public function products() {
        return $this->belongsToMany('Product');
    }

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'id',
        'title',
        'short_description',
        'description',
        'image',
        'max',
        'published'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'created_at',
        'created_by',
        'updated_at',
        'updated_by',
        'deleted_at',
        'deleted_by'
    ];
}
