<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class TempBookingItem extends Model
{
    use SoftDeletes;
    protected $table = 'ext_tempBookingItem';
    protected $primaryKey = 'id';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'id',
        'product_id',
        'bookableProduct_id',
        'productGroup_id',
        'bookingTimes_id',
        'quantity',
        'sum',
        'tax',
        'price',
        'startTime',
        'endTime',
        'externComments',
        'project',
        'uid',
        'payment_provider_id',
        'created_at',
        'updated_at',
        'days',
        'eventUid',
        'ext_pg_paymentItem_id'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'deleted_at'
    ];
}
