<?php
namespace App\Services;

use DateTime;

class UtilService
{
    /**
     * Simple function that takes in DateTime object and returns "1. Januari" or "1. Januari 2021" depending on if year sent in is same as current (only show year if different year).
     * @param $date DateTime, The DateTime we want to be written out as string
     * @return string in day. month and possibly year last
     */
    public function getDateString(DateTime $date) : string {
        $month = ['Januari', 'February', 'Mars', 'April', 'Mai', 'Juni', 'Juli', 'Augusti', 'September', 'Oktober', 'November', 'Desember'];
        $result = '';
        if(isset($date)) {
          $result = $date->format('j') .'. '.$month[$date->format('n')-1];
          if($date->format('Y') != (new DateTime())->format('Y')) {
            $result .= ' ' . $date->format('Y');
          }
        }
        return $result;
    }

    /**
     * All the translations needed for the date picker in single object
     * @returns array containing all stranslation strings needed
     */
    public function getDatePickerTranslations() : array {
        $result = [
          'date.start_end_same' => __('date.start_end_same'),
          'date.cannot_book_all_days' => __('date.cannot_book_all_days'),
          'date.end_before_start' => __('date.end_before_start'),
          'date.footer_full_day' => __('date.footer_full_day'),
          'date.footer_full_days' => __('date.footer_full_days'),
          'date.footer_arrival' => __('date.footer_arrival'),
          'date.footer_book' => __('date.footer_book'),
          'date.unable_to_book' => __('date.unable_to_book')
        ];
        return $result;
      }
}