/**
 * First we will load all of this project's JavaScript dependencies which
 * includes Vue and other libraries. It is a great starting point when
 * building robust, powerful web applications using Vue and Laravel.
 */

// For now not using any modules in bootstrap that need js, only styling. Can probably write the small amount of styles in custom css and leave bootstrap.
//require('./bootstrap');

window.Vue = require('vue').default;

/**
 * The following block of code may be used to automatically register your
 * Vue components. It will recursively scan this directory for the Vue
 * components and automatically register them with their "basename".
 *
 * Eg. ./components/ExampleComponent.vue -> <example-component></example-component>
 */

// const files = require.context('./', true, /\.vue$/i)
// files.keys().map(key => Vue.component(key.split('/').pop().split('.')[0], files(key).default))

Vue.component('product-list-component', require('./components/ProductListComponent.vue').default);
Vue.component('product-component', require('./components/ProductComponent.vue').default);
Vue.component('product-header-component', require('./components/ProductHeaderComponent.vue').default);
Vue.component('product-times-component', require('./components/ProductTimesComponent.vue').default);
Vue.component('product-calendar-component', require('./components/ProductCalendarComponent.vue').default);
Vue.component('product-calendar-sub-component', require('./components/ProductCalendarSubComponent.vue').default);
Vue.component('booking-count-component', require('./components/BookingCountComponent.vue').default);
Vue.component('minus-plus-component', require('./components/MinusPlusComponent.vue').default);
Vue.component('package-component', require('./components/CreateBookingPackageComponent.vue').default);
Vue.component('date-range-picker-component', require('./components/DateRangePickerComponent.vue').default);
Vue.component('extra-options-component', require('./components/ExtraOptionsComponent.vue').default);
Vue.component('main-booking-item-component', require('./components/MainBookingItemComponent.vue').default);
Vue.component('booking-item-additional-component', require('./components/BookingItemAdditionalComponent.vue').default);

// Global variables
//Vue.prototype.$server = 'http://localhost/dev/git/external-booking/public';
//Vue.prototype.$server = 'http://192.168.1.184/dev/git/external-booking/public';
Vue.prototype.$server = 'https://btest1.ledaco.net/external/public';

/**
 * Next, we will create a fresh Vue application instance and attach it to
 * the page. Then, you may begin adding components to this application
 * or customize the JavaScript scaffolding to fit your unique needs.
 */
const app = new Vue({
    el: '#app',
});


//require('./guest-count');