import { shallowMount, mount, shallow } from '@vue/test-utils'
import DateRangePicker from '@/components/DateRangePicker.vue'

// propsData: { "data": {"disabledDates":["2021-09-05","2021-09-06","2021-09-07","2021-09-08","2021-08-09"],"highlighted":["2021-08-11","2021-08-12","2021-08-13","2021-08-14","2021-08-15"],"date_translations":{"date.start_end_same":"Avresedatum f\u00e5r inte vara samma och ankomstdatum","date.cannot_book_all_days":"Det g\u00e5r inte att boka alla dagarna","date.end_before_start":"Avresedatum f\u00e5r inte vara f\u00f6re ankomstdatum","date.footer_full_day":"Ankomst {0}, Avresa {1}: {2} natt","date.footer_full_days":"Ankomst {0}, Avresa {1}: {2} n\u00e4tter","date.footer_arrival":"Ankomst {0}","date.unable_to_book":"Det g\u00e5r inte att boka detta datum"}} }

// Start by getting today
let d = new Date();
d.setMinutes(d.getMinutes() - d.getTimezoneOffset());
// And output only the date part
const dateToCheck = d.toISOString().slice(0,10);
const today = new Date(dateToCheck);
let yesterday = new Date(dateToCheck);
yesterday.setDate(yesterday.getDate() - 1);
let tomorrow = new Date(dateToCheck);
tomorrow.setDate(tomorrow.getDate() + 1);

describe('DateRangePicker.vue', () => {
  it('checking if dates are disabled or not by only setting disabledDate', () => {
    const wrapper = shallowMount(DateRangePicker, {
      propsData: { "data": {"disabledDates":[dateToCheck]} }
    });
    // Today has should be disabled
    expect(wrapper.vm.dateCheck(today)).toBeTruthy();
    
    // Yesterday has should be disabled
    expect(wrapper.vm.dateCheck(yesterday)).toBeTruthy();

    // Tomorrow should NOT be disabled
    expect(wrapper.vm.dateCheck(tomorrow)).toBeFalsy();
  });

  it('checking if dates are disabled or not by only setting enabledDates', () => {
    const wrapper = shallowMount(DateRangePicker, {
      propsData: { "data": {"enabledDates":[dateToCheck]} }
    });
    // Today has should NOT be disabled
    let date = new Date(dateToCheck);
    expect(wrapper.vm.dateCheck(today)).toBeFalsy();
    
    // Yesterday has should be disabled
    expect(wrapper.vm.dateCheck(yesterday)).toBeTruthy();

    // Tomorrow should be disabled
    expect(wrapper.vm.dateCheck(tomorrow)).toBeTruthy();
  });

  // it('asdf', done => {
  //   const wrapper = mount(DateRangePicker, {
  //     propsData: { "data": {"disabledDates":[dateToCheck]} }
  //   });
    //let element = document.querySelector('[title="' + dateToCheck + '"]').trigger('hover');
    //let element = wrapper.find('[title="' + dateToCheck + '"]').trigger('hover');
    // const td = shallow(<td class='asdf' title='2021-08-10'></td>);
    // td.find('td').simulate('hover');
    // console.log('Message: ' + wrapper.vm.message);
    // wrapper.find('.mx-input').trigger('click').then(() => {
    //   setTimeout(() => {
    //     console.log(wrapper);
    //   wrapper.find('.today').trigger('hover').then(() => {
    //     console.log('Message: ' + wrapper.vm.message);
    //     done();
    //   });
      
    // }, 100);
    //});
    //.trigger('click').then((x) => {
    //   setTimeout(() => {
    //     wrapper.find('.today').trigger('hover').then(() => {
    //       setTimeout(() => {
    //         console.log('Message: ' + wrapper.vm.message);
    //       },100);
    //     });
    //   },100);
    // });
    //wrapper.vm.dateHover(element);
  // });
  // Need more TESTS!!!!
});
