const mix = require('laravel-mix');
const fs = require('fs');
const path = require('path');

/*
 |--------------------------------------------------------------------------
 | Mix Asset Management
 |--------------------------------------------------------------------------
 |
 | Mix provides a clean, fluent API for defining some Webpack build steps
 | for your Laravel application. By default, we are compiling the Sass
 | file for the application as well as bundling up all the JS files.
 |
 */

mix.js('resources/js/app.js', 'public/js')
    .sass('resources/sass/app.scss', 'public/css')
    .vue()
    .after(s => {
        fs.readFile(path.resolve('public/css', 'app.css'), 'utf8' , (readError, data) => {
            if (readError) {
                console.error("\x1b[31mError: \x1b[0m" + readError);
                return;
            }

            // Local
            // var result = data.replace('/fonts/vendor/bootstrap-icons/bootstrap-icons.woff2', 'http://localhost/dev/git/external-booking/public/fonts/bootstrap-icons.woff2')
            //                 .replace('/fonts/vendor/bootstrap-icons/bootstrap-icons.woff', 'http://localhost/dev/git/external-booking/public/fonts/bootstrap-icons.woff');
            // Remote local
            // var result = data.replace('/fonts/vendor/bootstrap-icons/bootstrap-icons.woff2', 'http://192.168.1.184/dev/git/external-booking/public/fonts/bootstrap-icons.woff2')
            //                  .replace('/fonts/vendor/bootstrap-icons/bootstrap-icons.woff', 'http://192.168.1.184/dev/git/external-booking/public/fonts/bootstrap-icons.woff');
            // Test
            var result = data.replace('/fonts/vendor/bootstrap-icons/bootstrap-icons.woff2', 'https://btest1.ledaco.net/external/public/fonts/bootstrap-icons.woff2')
                             .replace('/fonts/vendor/bootstrap-icons/bootstrap-icons.woff', 'https://btest1.ledaco.net/external/public/fonts/bootstrap-icons.woff');
            // Prod
            // var result = data.replace('/fonts/vendor/bootstrap-icons/bootstrap-icons.woff2', 'https://bokning.nyaslottet.se/fonts/bootstrap-icons.woff2')
            //                 .replace('/fonts/vendor/bootstrap-icons/bootstrap-icons.woff', 'https://bokning.nyaslottet.se//fonts/bootstrap-icons.woff');
            
            
            fs.writeFile(path.resolve('public/css', 'app.css'), result, writeError => {
                if (writeError) {
                    console.error("\x1b[31mError: \x1b[0m" + writeError);
                    return;
                }
    
                console.log("Relative theme directory references replaced to full urls!");
            });
        })
    })
    .sourceMaps()
